
#include"Timestamp.h"

#include <Common.h>
#include "RTC.h"


int TIMENotify = 0;
char FINAL_DATA[40];

#define SYSTICK_EACH_10_HZ (10u)
#define SYSTICK_RELOAD (CYDEV_BCLK__SYSCLK__HZ / SYSTICK_EACH_10_HZ)
CY_ISR_PROTO(SysTickIsrHandler);


void Timestamp_Measure(void)
{
 
     uint32 time,date;
      
    char date_Buffer[20],time_Buffer[20];
  
  
    CYBLE_GATTS_HANDLE_VALUE_NTF_T      TIMERHandle;
    

    time=RTC_GetTime(); 
    date=RTC_GetDate();
    memset(date_Buffer,0,sizeof(date_Buffer));
    memset(time_Buffer,0,sizeof(time_Buffer));
    sprintf(time_Buffer,"%d:%d:%d",RTC_GetHours(time),RTC_GetMinutes(time),RTC_GetSecond(time));
    sprintf(date_Buffer,"%d-%d-%d",RTC_GetDay(date),RTC_GetMonth(date),RTC_GetYear(date));
    if(RTC_AM==RTC_GetAmPm(time))
    {
        strcat(time_Buffer," AM");
    }
    else if(RTC_PM==RTC_GetAmPm(time))
    {
        
        strcat(time_Buffer," PM");
    }
    

    TIMERHandle.attrHandle =CYBLE_CS3_CSCC3_CHAR_HANDLE  ;
    TIMERHandle.value.val = time_Buffer;
    //TIMERHandle.value.val = FINAL_DATA;
    TIMERHandle.value.len = 19;
        
    CyBle_GattsWriteAttributeValue(&TIMERHandle,0,&ConnectionHandle,0);
        
    if(TIMENotify )
    CyBle_GattsNotification(ConnectionHandle,&TIMERHandle);
    
    memset(FINAL_DATA,0,sizeof(FINAL_DATA));
    
}


void set_rtc(void)
{
      
    RTC_Start();
    RTC_SetPeriod(1u,SYSTICK_EACH_10_HZ);

    uint32 i;
    /* Start Systick component*/
    CySysTickStart();
    /*config Systick Timer to Generate interrupt every 100ms*/
    CySysTickSetReload(SYSTICK_RELOAD);
    /*Find unused Callback Slot*/
    for (i=0u; i <CY_SYS_SYST_NUM_OF_CALLBACKS; ++i)
    {
        if (CySysTickGetCallback(i) == NULL)
        {
            /*Set Callback */
            CySysTickSetCallback(i,SysTickIsrHandler);
            break;
        }
     }   
   
 }

void SysTickIsrHandler(void)
{
    RTC_Update();
}   